/**
 * Module:  firmware
 * Version: 1v2
 * Build:   6ee030bb6889ef7fa8bd871765d4954233229644
 * File:    src/switchReg.S
 *
 * The copyrights, all other intellectual and industrial 
 * property rights are retained by XMOS and/or its licensors. 
 * Terms and conditions covering the use of this code can
 * be found in the Xmos End User License Agreement.
 *
 * Copyright XMOS Ltd 2009
 **/                                   

#include <xs1_user.h>
.text


//void setRegVal(int psctl, int reg, int procc, int n);

.globl	setRegVal,"f{0}(si,si,si,si)"
.align	2
.type setRegVal,@function
setRegVal:
  extsp	1
  stw r4, sp[0]
  //mov r3, r0
  mov r11, r1
 
  ldc r1, 0xc30c
  ldc r4, 0xc20c
  bt r0, psctrl	

  mov r4, r1

psctrl:
  shl r1, r2, 16
  or r1, r1, r4
 
  getr r0, 2
  setd res[r0], r1
	
  ldc r1, 0xc0			// CTOKEN_CWRITE
	
  outct res[r0], r1
	
  ldc r2, 0
  mov r1, r2

  outt res[r0], r1
	
  mov r1, r2
	
  outt res[r0], r1
	
  shr r1, r0, 8
	
  outt res[r0], r1
	
  mov r1, r2
  outt res[r0], r1
	
  mov r1, r11

  outt res[r0], r1
	
  mov r1, r2
	
  outt res[r0], r1
  mov r1, r2
  outt res[r0], r1
  mov r1, r2
  outt res[r0], r1
  //ldc r1, 128
  outt res[r0], r3
  mkmsk r2, 1
  mov r1, r2
  outct res[r0], r1
  mkmsk r1, 2
  chkct res[r0], r1
   
  mov r1, r2
  chkct res[r0], r1
  freer res[r0]
  ldw r4, sp[0]
  ldaw sp, sp[1]
  retsp 0

	.globl	setRegVal.nstackwords
	.linkset	setRegVal.nstackwords,1
	.globl	setRegVal.maxthreads
	.linkset	setRegVal.maxthreads,1
	.globl	setRegVal.maxtimers
	.linkset	setRegVal.maxtimers,0
	.globl	setRegVal.maxchanends
	.linkset	setRegVal.maxchanends,0
	.linkset	setRegVal.locnochandec,1
	.linkset	setRegVal.locnoside,1


