/**
 * Module:  firmware
 * Version: 1v2
 * Build:   6ee030bb6889ef7fa8bd871765d4954233229644
 * File:    src/common/include/xc1.h
 *
 * The copyrights, all other intellectual and industrial 
 * property rights are retained by XMOS and/or its licensors. 
 * Terms and conditions covering the use of this code can
 * be found in the Xmos End User License Agreement.
 *
 * Copyright XMOS Ltd 2009
 **/                                   

// XSK resource defines

#ifndef _xsk_h_
#define _xsk_h_

#include <xs1.h>

/*** Core 0 ***/

// Ports
#define PORT_CLED_0  XS1_PORT_4C       // "Clock" LEDs
#define PORT_CLED_1  XS1_PORT_4A
#define PORT_CLED_2  XS1_PORT_4B
#define PORT_CLED_GR XS1_PORT_1E       // Green/Red select lines
#define PORT_CLED_RD XS1_PORT_1F

#define PORT_KLED    XS1_PORT_8D       // "Key" LEDs (Note: on upper 4-bits)

#define PORT_KEY     XS1_PORT_4D       // Buttons/Keys

#define PORT_SPK     XS1_PORT_1K       // Speaker

#define PORT_UART_RX XS1_PORT_1H       // UART (via FTDI)
#define PORT_UART_TX XS1_PORT_1I



// Clockblocks

#endif
