/**
 * Module:  firmware
 * Version: 1v2
 * Build:   6ee030bb6889ef7fa8bd871765d4954233229644
 * File:    src/common/softReset/doneOverride.S
 *
 * The copyrights, all other intellectual and industrial 
 * property rights are retained by XMOS and/or its licensors. 
 * Terms and conditions covering the use of this code can
 * be found in the Xmos End User License Agreement.
 *
 * Copyright XMOS Ltd 2009
 **/                                   

    .globl _done, "f{0}(0)"
    .globl _done.nstackwords
    .globl _done.maxchanends
    .globl _done.maxtimers
    .globl _done.maxthreads
    .linkset _done.nstackwords, 0
    .linkset _done.maxchanends, 0
    .linkset _done.maxtimers, 0
    .linkset _done.maxthreads, 0
    .text
    .align 2
_done:
  ldw     r0, dp[_rebootAddr]
  bau     r0

    .section .dp.data, "adw", @progbits
    .align 4
_rebootAddr:
    .word 0xffffc000


